open util/ordering[Desktop]

sig Desktop {
     icons: set Icon
} 

sig Icon {}

pred init [d: Desktop, i: set Icon] {
    d.icons = i
}

pred cut [d: Desktop, i: Icon] {
    d.icons = d.prev.icons - i
}

pred paste [d: Desktop, i: Icon] {
    d.icons = d.prev.icons + i
}

pred Desktop_changes {
    some i: set Icon | init [first, i]
    all d: Desktop - first | 
        (some i: d.prev.icons | cut[d, i]) or 
        (some i: Icon - d.prev.icons | paste[d, i])
}

run Desktop_changes for 5
