module Complement
/***************************
            COMPLEMENT
****************************/

// The complement of a relation R contains
// all ordered pairs of the Cartesian product A x A
// which are not members of R.

fun complement (A: set univ, R: univ->univ): univ->univ {
    (A -> A) - R  
}
