sig elem {}

one sig Ord {
    First: elem,
    Next: elem -> elem
} {
    no a: elem | (a -> First) in Next   // First is the first atom in the list
    // Constrain Next to be ordered like Next in the ordering module
    (elem <: iden) & Next = (none -> none)   // Constrain Next to be irreflexive
    Next.Next & Next = none -> none  // Constrain Next to be intransitive 
    (Next & ~Next) = none -> none    // Constrain Next to be asymmetric
    Next + ~Next + (elem <: iden) != (elem -> elem)   // Constrain Next to be non-connected
    #(elem.Next) = #Next   // Constrain Next to be injective
    #(Next.elem) = #Next    // Constrain Next to be functional
    #Next = minus[#elem,1]  // Constraint Next to contain all atoms in elem
}

fun first: one elem { Ord.First }
fun next : elem->elem { Ord.Next }
fun last: one elem { elem - (next.elem) }

pred Show {
    #elem > 2
}

run Show
