open util/ordering[Desktop]

sig Desktop {
     icons: set Icon
} 

sig Icon {}

fact init {
    some i: set Icon | first.icons = i
}

// Desktop N cannot hold any old set of icons.
// No, it is derived from the previous desktop: 
// It either has the icons on the previous desktop
// minus one or plus one.
fact Desktops_through_cut_and_paste {
    all d: Desktop - first | 
        (some i: d.prev.icons | d.icons = d.prev.icons - i) or
        (some i: Icon - d.prev.icons | d.icons = d.prev.icons + i)
}

run {} for 5
