open util/ordering[Desktop]

sig Desktop {
     icons: set Icon
} 

sig Icon {}

abstract sig Event {
    desktop: Desktop
}

one sig init extends Event {
    icons: set Icon
} {
    first = desktop
   first.@icons = icons
}

sig cut extends Event {
    icon: Icon
} {
    icon in desktop.prev.icons
   desktop.icons = desktop.prev.icons - icon
}

sig paste extends Event {
    icon: Icon
} {
    icon not in desktop.prev.icons
   desktop.icons = desktop.prev.icons + icon
}

pred Desktop_changes {
    first in init.desktop
    all d: Desktop - first | 
        (d in cut.desktop) or (d in paste.desktop)
}

run Desktop_changes for 5
