// Given a set A and a relation R in A, R is reflexive 
// if and only if all the ordered pairs of the form (x, x) 
// are in R for every x in A.

sig A {}

one sig Test {
    R: A -> A
} 

// Equivalent models of "reflexive"
assert areEquivalentModels {
   (A <: iden) in Test.R 
   iff 
   all x: A | (x -> x) in Test.R
}
check areEquivalentModels
