open util/ordering[House]

sig House {
     style: Style
} 

enum Style { colonial, ranch }

one sig HouseStyle {
    connections: House -> House
} 

fact Chain {
    all h: House | HouseStyle.connections[h] = h.next.next
}

fact Colonials_start_at_first_house {
     all h: (first <: House).*(HouseStyle.connections) | h.style = colonial
}

fact Ranches_start_at_second_house {
     all h: (first <: House).next.*(HouseStyle.connections) | h.style = ranch
}

run {} for 5
