/***************************
            REFLEXIVE PROPERTY
****************************/

// Given a set A and a relation R in A, R is reflexive 
// if and only if all the ordered pairs of the form (x, x) 
// are in R for every x in A.

sig A {}

one sig Test {
    R: A -> A
} 

run Show {
    #A > 2
    reflexive [A, Test.R]
}

// Given a set A and a relation R in A, R is reflexive 
// if and only if all the ordered pairs of the form (x, x) 
// are in R for every x in A.
pred reflexive (A: set univ, R: univ->univ) {
    all x: A | (x -> x) in R
}
